ContainerBase (Tomcat API Documentation)
Keywords: org.apache.catalina.core.ContainerBase class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.core
Class ContainerBase

    java.lang.Object
      org.apache.catalina.core.ContainerBase

All Implemented Interfaces:
  java.io.Serializable, javax.management.MBeanRegistration, Container, Lifecycle, Pipeline

Direct Known Subclasses:
  StandardContext, StandardEngine, StandardHost, StandardWrapper

    public abstract class ContainerBase

extends java.lang.Object
implements Container, Lifecycle, Pipeline, javax.management.MBeanRegistration, java.io.Serializable

Abstract implementation of the Container interface, providing common functionality required by nearly every implementation. Classes extending this base class must implement `getInfo()`, and may implement a replacement for `invoke()`.

All subclasses of this abstract base class will include support for a Pipeline object that defines the processing to be performed for each request received by the `invoke()` method of this class, utilizing the "Chain of Responsibility" design pattern. A subclass should encapsulate its own processing functionality as a `Valve`, and configure this Valve into the pipeline by calling `setBasic()`.

This implementation fires property change events, per the JavaBeans design pattern, for changes in singleton properties. In addition, it fires the following `ContainerEvent` events to listeners who register themselves with `addContainerListener()`:

Type | Data | Description
--- | --- | ---
`addChild` | `Container` | Child container added to this Container.
`addValve` | `Valve` | Valve added to this Container.
`removeChild` | `Container` | Child container removed from this Container.
`removeValve` | `Valve` | Valve removed from this Container.
`start` | `null` | Container was started.
`stop` | `null` | Container was stopped.

Subclasses that fire additional events should document them in the class comments of the implementation class.

Author:
  Craig R. McClanahan
See Also:
  Serialized Form

Nested Class Summary
`protected class` | `ContainerBase.ContainerBackgroundProcessor` Private thread class to invoke the backgroundProcess method of this container and its children after a fixed delay.
`protected class` | `ContainerBase.PrivilegedAddChild` Perform addChild with the permissions of this class.

Field Summary
`protected int` | `backgroundProcessorDelay` The processor delay for this component.
`protected java.util.HashMap` | `children` The child Containers belonging to this Container, keyed by name.
`protected Cluster` | `cluster` The cluster with which this Container is associated.
`protected javax.management.ObjectName` | `controller`
`protected java.lang.String` | `domain`
`protected boolean` | `initialized`
`protected LifecycleSupport` | `lifecycle` The lifecycle event support for this component.
`protected java.util.ArrayList` | `listeners` The container event listeners for this Container.
`protected Loader` | `loader` The Loader implementation with which this Container is associated.
`protected Log` | `logger` The Logger implementation with which this Container is associated.
`protected java.lang.String` | `logName` Associated logger name.
`protected Manager` | `manager` The Manager implementation with which this Container is associated.
`protected javax.management.MBeanServer` | `mserver`
`protected java.lang.String` | `name` The human-readable name of this Container.
`protected javax.management.ObjectName` | `oname`
`protected Container` | `parent` The parent Container to which this Container is a child.
`protected java.lang.ClassLoader` | `parentClassLoader` The parent class loader to be configured when we install a Loader.
`protected Pipeline` | `pipeline` The Pipeline object with which this Container is associated.
`protected Realm` | `realm` The Realm with which this Container is associated.
`protected javax.naming.directory.DirContext` | `resources` The resources DirContext object with which this Container is associated.
`protected static StringManager` | `sm` The string manager for this package.
`protected boolean` | `startChildren` Will children be started automatically when they are added.
`protected boolean` | `started` Has this component been started?
`protected java.lang.String` | `suffix`
`protected java.beans.PropertyChangeSupport` | `support` The property change support for this component.
`protected java.lang.String` | `type`

Fields inherited from interface org.apache.catalina.Container
`ADD_CHILD_EVENT, ADD_MAPPER_EVENT, ADD_VALVE_EVENT, REMOVE_CHILD_EVENT, REMOVE_MAPPER_EVENT, REMOVE_VALVE_EVENT`

Fields inherited from interface org.apache.catalina.Lifecycle
`AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, DESTROY_EVENT, INIT_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

Constructor Summary
`ContainerBase()`

Method Summary
`void` | `addChild(Container child)` Add a new child Container to those associated with this Container, if supported.
`void` | `addContainerListener(ContainerListener listener)` Add a container event listener to this component.
`void` | `addLifecycleListener(LifecycleListener listener)` Add a lifecycle event listener to this component.
`void` | `addPropertyChangeListener(java.beans.PropertyChangeListener listener)` Add a property change listener to this component.
`void` | `addValve(Valve valve)` Add a new Valve to the end of the pipeline associated with this Container.
`void` | `backgroundProcess()` Execute a periodic task, such as reloading, etc.
`javax.management.ObjectName` | `createObjectName(java.lang.String domain, javax.management.ObjectName parent)`
`void` | `destroy()`
`Container` | `findChild(java.lang.String name)` Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`
`Container[]` | `findChildren()` Return the set of children Containers associated with this Container.
`ContainerListener[]` | `findContainerListeners()` Return the set of container listeners associated with this Container.
`LifecycleListener[]` | `findLifecycleListeners()` Get the lifecycle listeners associated with this lifecycle.
`void` | `fireContainerEvent(java.lang.String type, java.lang.Object data)` Notify all container event listeners that a particular event has occurred for this Container.
`int` | `getBackgroundProcessorDelay()` Get the delay between the invocation of the backgroundProcess method on this container and its children.
`Valve` | `getBasic()` Return the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).
`javax.management.ObjectName[]` | `getChildren()`
`Cluster` | `getCluster()` Return the Cluster with which this Container is associated.
`java.lang.String` | `getContainerSuffix()`
`java.lang.String` | `getDomain()`
`Valve` | `getFirst()` Return the first valve in the pipeline.
`java.lang.String` | `getInfo()` Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.
`javax.management.ObjectName` | `getJmxName()`
`protected java.lang.String` | `getJSR77Suffix()`
`Loader` | `getLoader()` Return the Loader with which this Container is associated.
`Log` | `getLogger()` Return the Logger with which this Container is associated.
`Manager` | `getManager()` Return the Manager with which this Container is associated.
`java.lang.Object` | `getMappingObject()` Return an object which may be utilized for mapping to this component.
`java.lang.String` | `getName()` Return a name string (suitable for use by humans) that describes this Container.
`java.lang.String` | `getObjectName()` Return the JMX name associated with this container.
`Container` | `getParent()` Return the Container for which this Container is a child, if there is one.
`java.lang.ClassLoader` | `getParentClassLoader()` Return the parent class loader (if any) for this web application.
`javax.management.ObjectName` | `getParentName()`
`Pipeline` | `getPipeline()` Return the Pipeline object that manages the Valves associated with this Container.
`Realm` | `getRealm()` Return the Realm with which this Container is associated.
`javax.naming.directory.DirContext` | `getResources()` Return the resources DirContext object with which this Container is associated.
`boolean` | `getStartChildren()` Return if children of this container will be started automatically when they are added to this container.
`java.lang.String` | `getType()`
`javax.management.ObjectName[]` | `getValveObjectNames()`
`Valve[]` | `getValves()` Return the set of Valves in the pipeline associated with this Container, including the basic Valve (if any).
`void` | `init()` Init method, part of the MBean lifecycle.
`void` | `invoke(Request request, Response response)` Process the specified Request, to produce the corresponding Response, by invoking the first Valve in our pipeline (if any), or the basic Valve otherwise.
`protected java.lang.String` | `logName()` Return the abbreviated name of this container for logging messsages
`void` | `postDeregister()`
`void` | `postRegister(java.lang.Boolean registrationDone)`
`void` | `preDeregister()`
`javax.management.ObjectName` | `preRegister(javax.management.MBeanServer server, javax.management.ObjectName name)`
`void` | `removeChild(Container child)` Remove an existing child Container from association with this parent Container.
`void` | `removeContainerListener(ContainerListener listener)` Remove a container event listener from this component.
`void` | `removeLifecycleListener(LifecycleListener listener)` Remove a lifecycle event listener from this component.
`void` | `removePropertyChangeListener(java.beans.PropertyChangeListener listener)` Remove a property change listener from this component.
`void` | `removeValve(Valve valve)` Remove the specified Valve from the pipeline associated with this Container, if it is found; otherwise, do nothing.
`void` | `setBackgroundProcessorDelay(int delay)` Set the delay between the invocation of the execute method on this container and its children.
`void` | `setBasic(Valve valve)` Set the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).
`void` | `setCluster(Cluster cluster)` Set the Cluster with which this Container is associated.
`void` | `setDomain(java.lang.String domain)`
`void` | `setLoader(Loader loader)` Set the Loader with which this Container is associated.
`void` | `setManager(Manager manager)` Set the Manager with which this Container is associated.
`void` | `setName(java.lang.String name)` Set a name string (suitable for use by humans) that describes this Container.
`void` | `setParent(Container container)` Set the parent Container to which this Container is being added as a child.
`void` | `setParentClassLoader(java.lang.ClassLoader parent)` Set the parent class loader (if any) for this web application.
`void` | `setRealm(Realm realm)` Set the Realm with which this Container is associated.
`void` | `setResources(javax.naming.directory.DirContext resources)` Set the resources DirContext object with which this Container is associated.
`void` | `setStartChildren(boolean startChildren)` Set if children of this container will be started automatically when they are added to this container.
`void` | `start()` Prepare for active use of the public methods of this Component.
`void` | `stop()` Gracefully shut down active use of the public methods of this Component.
`protected void` | `threadStart()` Start the background thread that will periodically check for session timeouts.
`protected void` | `threadStop()` Stop the background thread that is periodically checking for session timeouts.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### children

    protected java.util.HashMap children

  The child Containers belonging to this Container, keyed by name.

### backgroundProcessorDelay

    protected int backgroundProcessorDelay

  The processor delay for this component.

### lifecycle

    protected LifecycleSupport lifecycle

  The lifecycle event support for this component.

### listeners

    protected java.util.ArrayList listeners

  The container event listeners for this Container.

### loader

    protected Loader loader

  The Loader implementation with which this Container is associated.

### logger

    protected Log logger

  The Logger implementation with which this Container is associated.

### logName

    protected java.lang.String logName

  Associated logger name.

### manager

    protected Manager manager

  The Manager implementation with which this Container is associated.

### cluster

    protected Cluster cluster

  The cluster with which this Container is associated.

### name

    protected java.lang.String name

  The human-readable name of this Container.

### parent

    protected Container parent

  The parent Container to which this Container is a child.

### parentClassLoader

    protected java.lang.ClassLoader parentClassLoader

  The parent class loader to be configured when we install a Loader.

### pipeline

    protected Pipeline pipeline

  The Pipeline object with which this Container is associated.

### realm

    protected Realm realm

  The Realm with which this Container is associated.

### resources

    protected javax.naming.directory.DirContext resources

  The resources DirContext object with which this Container is associated.

### sm

    protected static StringManager sm

  The string manager for this package.

### started

    protected boolean started

  Has this component been started?

### initialized

    protected boolean initialized

### startChildren

    protected boolean startChildren

  Will children be started automatically when they are added.

### support

    protected java.beans.PropertyChangeSupport support

  The property change support for this component.

### type

    protected java.lang.String type

### domain

    protected java.lang.String domain

### suffix

    protected java.lang.String suffix

### oname

    protected javax.management.ObjectName oname

### controller

    protected javax.management.ObjectName controller

### mserver

    protected transient javax.management.MBeanServer mserver

Constructor Detail

### ContainerBase

    public ContainerBase()

Method Detail

### getBackgroundProcessorDelay

    public int getBackgroundProcessorDelay()

  Get the delay between the invocation of the backgroundProcess method on this container and its children. Child containers will not be invoked if their delay value is not negative (which would mean they are using their own thread). Setting this to a positive value will cause a thread to be spawn. After waiting the specified amount of time, the thread will invoke the executePeriodic method on this container and all its children.

  Specified by:
    `getBackgroundProcessorDelay` in interface `Container`

### setBackgroundProcessorDelay

    public void setBackgroundProcessorDelay(int delay)

  Set the delay between the invocation of the execute method on this container and its children.

  Specified by:
    `setBackgroundProcessorDelay` in interface `Container`
  Parameters:
    `delay` - The delay in seconds between the invocation of backgroundProcess methods

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.

  Specified by:
    `getInfo` in interface `Container`

### getLoader

    public Loader getLoader()

  Return the Loader with which this Container is associated. If there is no associated Loader, return the Loader associated with our parent Container (if any); otherwise, return `null`.

  Specified by:
    `getLoader` in interface `Container`

### setLoader

    public void setLoader(Loader loader)

  Set the Loader with which this Container is associated.

  Specified by:
    `setLoader` in interface `Container`
  Parameters:
    `loader` - The newly associated loader

### getLogger

    public Log getLogger()

  Return the Logger with which this Container is associated. If there is no associated Logger, return the Logger associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getLogger` in interface `Container`

### getManager

    public Manager getManager()

  Return the Manager with which this Container is associated. If there is no associated Manager, return the Manager associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getManager` in interface `Container`

### setManager

    public void setManager(Manager manager)

  Set the Manager with which this Container is associated.

  Specified by:
    `setManager` in interface `Container`
  Parameters:
    `manager` - The newly associated Manager

### getMappingObject

    public java.lang.Object getMappingObject()

  Return an object which may be utilized for mapping to this component.

  Specified by:
    `getMappingObject` in interface `Container`

### getCluster

    public Cluster getCluster()

  Return the Cluster with which this Container is associated. If there is no associated Cluster, return the Cluster associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getCluster` in interface `Container`

### setCluster

    public void setCluster(Cluster cluster)

  Set the Cluster with which this Container is associated.

  Specified by:
    `setCluster` in interface `Container`
  Parameters:
    `cluster` - The newly associated Cluster

### getName

    public java.lang.String getName()

  Return a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

  Specified by:
    `getName` in interface `Container`

### setName

    public void setName(java.lang.String name)

  Set a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

  Specified by:
    `setName` in interface `Container`
  Parameters:
    `name` - New name of this container
  Throws:
    `java.lang.IllegalStateException` - if this Container has already been added to the children of a parent Container (after which the name may not be changed)

### getStartChildren

    public boolean getStartChildren()

  Return if children of this container will be started automatically when they are added to this container.

### setStartChildren

    public void setStartChildren(boolean startChildren)

  Set if children of this container will be started automatically when they are added to this container.

  Parameters:
    `startChildren` - New value of the startChildren flag

### getParent

    public Container getParent()

  Return the Container for which this Container is a child, if there is one. If there is no defined parent, return `null`.

  Specified by:
    `getParent` in interface `Container`

### setParent

    public void setParent(Container container)

  Set the parent Container to which this Container is being added as a child. This Container may refuse to become attached to the specified Container by throwing an exception.

  Specified by:
    `setParent` in interface `Container`
  Parameters:
    `container` - Container to which this Container is being added as a child
  Throws:
    `java.lang.IllegalArgumentException` - if this Container refuses to become attached to the specified Container

### getParentClassLoader

    public java.lang.ClassLoader getParentClassLoader()

  Return the parent class loader (if any) for this web application. This call is meaningful only after a Loader has been configured.

  Specified by:
    `getParentClassLoader` in interface `Container`

### setParentClassLoader

    public void setParentClassLoader(java.lang.ClassLoader parent)

  Set the parent class loader (if any) for this web application. This call is meaningful only before a Loader has been configured, and the specified value (if non-null) should be passed as an argument to the class loader constructor.

  Specified by:
    `setParentClassLoader` in interface `Container`
  Parameters:
    `parent` - The new parent class loader

### getPipeline

    public Pipeline getPipeline()

  Return the Pipeline object that manages the Valves associated with this Container.

  Specified by:
    `getPipeline` in interface `Container`

### getRealm

    public Realm getRealm()

  Return the Realm with which this Container is associated. If there is no associated Realm, return the Realm associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getRealm` in interface `Container`

### setRealm

    public void setRealm(Realm realm)

  Set the Realm with which this Container is associated.

  Specified by:
    `setRealm` in interface `Container`
  Parameters:
    `realm` - The newly associated Realm

### getResources

    public javax.naming.directory.DirContext getResources()

  Return the resources DirContext object with which this Container is associated. If there is no associated resources object, return the resources associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getResources` in interface `Container`

### setResources

    public void setResources(javax.naming.directory.DirContext resources)

  Set the resources DirContext object with which this Container is associated.

  Specified by:
    `setResources` in interface `Container`
  Parameters:
    `resources` - The newly associated DirContext

### addChild

    public void addChild(Container child)

  Add a new child Container to those associated with this Container, if supported. Prior to adding this Container to the set of children, the child's `setParent()` method must be called, with this Container as an argument. This method may thrown an `IllegalArgumentException` if this Container chooses not to be attached to the specified Container, in which case it is not added

  Specified by:
    `addChild` in interface `Container`
  Parameters:
    `child` - New child Container to be added
  Throws:
    `java.lang.IllegalArgumentException` - if this exception is thrown by the `setParent()` method of the child Container
    `java.lang.IllegalArgumentException` - if the new child does not have a name unique from that of existing children of this Container
    `java.lang.IllegalStateException` - if this Container does not support child Containers

### addContainerListener

    public void addContainerListener(ContainerListener listener)

  Add a container event listener to this component.

  Specified by:
    `addContainerListener` in interface `Container`
  Parameters:
    `listener` - The listener to add

### addPropertyChangeListener

    public void addPropertyChangeListener(java.beans.PropertyChangeListener listener)

  Add a property change listener to this component.

  Specified by:
    `addPropertyChangeListener` in interface `Container`
  Parameters:
    `listener` - The listener to add

### findChild

    public Container findChild(java.lang.String name)

  Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`

  Specified by:
    `findChild` in interface `Container`
  Parameters:
    `name` - Name of the child Container to be retrieved

### findChildren

    public Container[] findChildren()

  Return the set of children Containers associated with this Container. If this Container has no children, a zero-length array is returned.

  Specified by:
    `findChildren` in interface `Container`

### findContainerListeners

    public ContainerListener[] findContainerListeners()

  Return the set of container listeners associated with this Container. If this Container has no registered container listeners, a zero-length array is returned.

  Specified by:
    `findContainerListeners` in interface `Container`

### invoke

    public void invoke(Request request,
                       Response response)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Process the specified Request, to produce the corresponding Response, by invoking the first Valve in our pipeline (if any), or the basic Valve otherwise.

  Specified by:
    `invoke` in interface `Container`
  Parameters:
    `request` - Request to be processed
    `response` - Response to be produced
  Throws:
    `java.lang.IllegalStateException` - if neither a pipeline or a basic Valve have been configured for this Container
    `java.io.IOException` - if an input/output error occurred while processing
    `javax.servlet.ServletException` - if a ServletException was thrown while processing this request

### removeChild

    public void removeChild(Container child)

  Remove an existing child Container from association with this parent Container.

  Specified by:
    `removeChild` in interface `Container`
  Parameters:
    `child` - Existing child Container to be removed

### removeContainerListener

    public void removeContainerListener(ContainerListener listener)

  Remove a container event listener from this component.

  Specified by:
    `removeContainerListener` in interface `Container`
  Parameters:
    `listener` - The listener to remove

### removePropertyChangeListener

    public void removePropertyChangeListener(java.beans.PropertyChangeListener listener)

  Remove a property change listener from this component.

  Specified by:
    `removePropertyChangeListener` in interface `Container`
  Parameters:
    `listener` - The listener to remove

### addLifecycleListener

    public void addLifecycleListener(LifecycleListener listener)

  Add a lifecycle event listener to this component.

  Specified by:
    `addLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to add

### findLifecycleListeners

    public LifecycleListener[] findLifecycleListeners()

  Get the lifecycle listeners associated with this lifecycle. If this Lifecycle has no listeners registered, a zero-length array is returned.

  Specified by:
    `findLifecycleListeners` in interface `Lifecycle`

### removeLifecycleListener

    public void removeLifecycleListener(LifecycleListener listener)

  Remove a lifecycle event listener from this component.

  Specified by:
    `removeLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to remove

### start

    public void start()
               throws LifecycleException

  Prepare for active use of the public methods of this Component.

  Specified by:
    `start` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that prevents it from being started

### stop

    public void stop()
              throws LifecycleException

  Gracefully shut down active use of the public methods of this Component.

  Specified by:
    `stop` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that needs to be reported

### init

    public void init()
              throws java.lang.Exception

  Init method, part of the MBean lifecycle. If the container was added via JMX, it'll register itself with the parent, using the ObjectName conventions to locate the parent. If the container was added directly and it doesn't have an ObjectName, it'll create a name and register itself with the JMX console. On destroy(), the object will unregister.

  Throws:
    `java.lang.Exception`

### getParentName

    public javax.management.ObjectName getParentName()
                                              throws javax.management.MalformedObjectNameException

  Throws:
    `javax.management.MalformedObjectNameException`

### destroy

    public void destroy()
                 throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### addValve

    public void addValve(Valve valve)

  Add a new Valve to the end of the pipeline associated with this Container. Prior to adding the Valve, the Valve's `setContainer` method must be called, with this Container as an argument. The method may throw an `IllegalArgumentException` if this Valve chooses not to be associated with this Container, or `IllegalStateException` if it is already associated with a different Container.

  Specified by:
    `addValve` in interface `Pipeline`
  Parameters:
    `valve` - Valve to be added
  Throws:
    `java.lang.IllegalArgumentException` - if this Container refused to accept the specified Valve
    `java.lang.IllegalArgumentException` - if the specifie Valve refuses to be associated with this Container
    `java.lang.IllegalStateException` - if the specified Valve is already associated with a different Container

### getValveObjectNames

    public javax.management.ObjectName[] getValveObjectNames()

### getBasic

    public Valve getBasic()

  Return the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).

  Specified by:
    `getBasic` in interface `Pipeline`

### getFirst

    public Valve getFirst()

  Return the first valve in the pipeline.

  Specified by:
    `getFirst` in interface `Pipeline`

### getValves

    public Valve[] getValves()

  Return the set of Valves in the pipeline associated with this Container, including the basic Valve (if any). If there are no such Valves, a zero-length array is returned.

  Specified by:
    `getValves` in interface `Pipeline`

### removeValve

    public void removeValve(Valve valve)

  Remove the specified Valve from the pipeline associated with this Container, if it is found; otherwise, do nothing.

  Specified by:
    `removeValve` in interface `Pipeline`
  Parameters:
    `valve` - Valve to be removed

### setBasic

    public void setBasic(Valve valve)

  Set the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any). Prioer to setting the basic Valve, the Valve's `setContainer()` will be called, if it implements `Contained`, with the owning Container as an argument. The method may throw an `IllegalArgumentException` if this Valve chooses not to be associated with this Container, or `IllegalStateException` if it is already associated with a different Container.

  Specified by:
    `setBasic` in interface `Pipeline`
  Parameters:
    `valve` - Valve to be distinguished as the basic Valve

### backgroundProcess

    public void backgroundProcess()

  Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

  Specified by:
    `backgroundProcess` in interface `Container`

### fireContainerEvent

    public void fireContainerEvent(java.lang.String type,
                                   java.lang.Object data)

  Notify all container event listeners that a particular event has occurred for this Container. The default implementation performs this notification synchronously using the calling thread.

  Parameters:
    `type` - Event type
    `data` - Event data

### logName

    protected java.lang.String logName()

  Return the abbreviated name of this container for logging messsages

### getJmxName

    public javax.management.ObjectName getJmxName()

### getObjectName

    public java.lang.String getObjectName()

  Description copied from interface: `Container`
  Return the JMX name associated with this container.

  Specified by:
    `getObjectName` in interface `Container`

### getDomain

    public java.lang.String getDomain()

### setDomain

    public void setDomain(java.lang.String domain)

### getType

    public java.lang.String getType()

### getJSR77Suffix

    protected java.lang.String getJSR77Suffix()

### preRegister

    public javax.management.ObjectName preRegister(javax.management.MBeanServer server,
                                                   javax.management.ObjectName name)
                                            throws java.lang.Exception

  Specified by:
    `preRegister` in interface `javax.management.MBeanRegistration`
  Throws:
    `java.lang.Exception`

### postRegister

    public void postRegister(java.lang.Boolean registrationDone)

  Specified by:
    `postRegister` in interface `javax.management.MBeanRegistration`

### preDeregister

    public void preDeregister()
                       throws java.lang.Exception

  Specified by:
    `preDeregister` in interface `javax.management.MBeanRegistration`
  Throws:
    `java.lang.Exception`

### postDeregister

    public void postDeregister()

  Specified by:
    `postDeregister` in interface `javax.management.MBeanRegistration`

### getChildren

    public javax.management.ObjectName[] getChildren()

### createObjectName

    public javax.management.ObjectName createObjectName(java.lang.String domain,
                                                        javax.management.ObjectName parent)
                                                 throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### getContainerSuffix

    public java.lang.String getContainerSuffix()

### threadStart

    protected void threadStart()

  Start the background thread that will periodically check for session timeouts.

### threadStop

    protected void threadStop()

  Stop the background thread that is periodically checking for session timeouts.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.